Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionResidualAnalysisView.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionResidualAnalysisView.cs	(revision 15093)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis.Views/3.4/Regression/RegressionSolutionResidualAnalysisView.cs	(revision 15094)
@@ -91,4 +91,5 @@
       var doubleVars = ds.DoubleVariables.Where(vn => ds.GetDoubleValues(vn).Max() > ds.GetDoubleValues(vn).Min()).ToArray();
       var stringVars = ds.StringVariables.Where(vn => ds.GetStringValues(vn).Distinct().Skip(1).Any()).ToArray();
+      var dateTimeVars = ds.DateTimeVariables.Where(vn => ds.GetDateTimeValues(vn).Distinct().Skip(1).Any()).ToArray();
 
       // produce training and test values separately as they might overlap (e.g. for ensembles)
@@ -96,5 +97,5 @@
       int j = 0; // idx for predictedValues array
       foreach (var i in problemData.TrainingIndices) {
-        var run = CreateRunForIdx(i, problemData, doubleVars, stringVars);
+        var run = CreateRunForIdx(i, problemData, doubleVars, stringVars, dateTimeVars);
         var targetValue = ds.GetDoubleValue(problemData.TargetVariable, i);
         AddErrors(run, predictedValuesTrain[j++], targetValue);
@@ -106,5 +107,5 @@
       j = 0;
       foreach (var i in problemData.TestIndices) {
-        var run = CreateRunForIdx(i, problemData, doubleVars, stringVars);
+        var run = CreateRunForIdx(i, problemData, doubleVars, stringVars, dateTimeVars);
         var targetValue = ds.GetDoubleValue(problemData.TargetVariable, i);
         AddErrors(run, predictedValuesTest[j++], targetValue);
@@ -134,5 +135,5 @@
     }
 
-    private IRun CreateRunForIdx(int i, IRegressionProblemData problemData, IEnumerable<string> doubleVars, IEnumerable<string> stringVars) {
+    private IRun CreateRunForIdx(int i, IRegressionProblemData problemData, IEnumerable<string> doubleVars, IEnumerable<string> stringVars, IEnumerable<string> dateTimeVars) {
       var ds = problemData.Dataset;
       var run = new Run();
@@ -143,4 +144,7 @@
         run.Results.Add(variableName, new StringValue(ds.GetStringValue(variableName, i)));
       }
+      foreach (var variableName in dateTimeVars) {
+        run.Results.Add(variableName, new DateTimeValue(ds.GetDateTimeValue(variableName, i)));
+      }
       return run;
     }
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 15093)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Dataset.cs	(revision 15094)
@@ -181,4 +181,8 @@
     }
 
+    public IEnumerable<string> DateTimeVariables {
+      get { return variableValues.Where(p => p.Value is IList<DateTime>).Select(p => p.Key); }
+    }
+
     public IEnumerable<double> GetDoubleValues(string variableName) {
       return GetValues<double>(variableName);
@@ -215,4 +219,17 @@
       return new ReadOnlyCollection<string>(values);
     }
+
+    public DateTime GetDateTimeValue(string variableName, int row) {
+      var values = GetValues<DateTime>(variableName);
+      return values[row];
+    }
+    public IEnumerable<DateTime> GetDateTimeValues(string variableName, IEnumerable<int> rows) {
+      return GetValues<DateTime>(variableName, rows);
+    }
+    public ReadOnlyCollection<DateTime> GetReadOnlyDateTimeValues(string variableName) {
+      var values = GetValues<DateTime>(variableName);
+      return new ReadOnlyCollection<DateTime>(values);
+    }
+
 
     private IEnumerable<T> GetValues<T>(string variableName, IEnumerable<int> rows) {
Index: /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataset.cs
===================================================================
--- /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataset.cs	(revision 15093)
+++ /trunk/sources/HeuristicLab.Problems.DataAnalysis/3.4/Interfaces/IDataset.cs	(revision 15094)
@@ -31,4 +31,5 @@
     IEnumerable<string> DoubleVariables { get; }
     IEnumerable<string> StringVariables { get; }
+    IEnumerable<string> DateTimeVariables { get; }
 
     bool VariableHasType<T>(string variableName);
@@ -44,5 +45,8 @@
     ReadOnlyCollection<string> GetReadOnlyStringValues(string VariableName);
 
+    System.DateTime GetDateTimeValue(string variableName, int row);
     IEnumerable<DateTime> GetDateTimeValues(string variableName);
+    IEnumerable<DateTime> GetDateTimeValues(string variableName, IEnumerable<int> rows);
+    ReadOnlyCollection<DateTime> GetReadOnlyDateTimeValues(string variableName);
   }
 }